/* Configuration for GNU C-compiler for Sharp X680x0(Human68k) Series.
   Copyright (C) 1987, 1999, 2000 Free Software Foundation, Inc.
   Contributed by KQ|Takahisa Yokota (cao01480@pop02.odn.ne.jp)   

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


/* #defines that need visibility everywhere.  */
#define FALSE 0
#define TRUE  1

#ifdef IN_GCC
#include "auto-host.h"
#include "gansidecl.h"
/* This describes the machine the compiler is hosted on.  */
#define HOST_BITS_PER_CHAR      8
#define HOST_BITS_PER_SHORT    16
#define HOST_BITS_PER_INT      32
#define HOST_BITS_PER_LONG     32
#define HOST_BITS_PER_LONGLONG 64
#define HOST_WORDS_BIG_ENDIAN   0

#include "hwint.h"
#endif

#define ISKANJI(c)       iskanji (c)
#define ISKANJI2(c)      iskanji2 (c)
#define ISPRKANA(c)      isprkana (c)
#define TOLOWER(c)       tolower(c)
#define HUMAN68K_ASM
#define MOTOROLA
#define SDB_DEBUGGING_INFO

/* target machine dependencies.
   tm.h is a symbolic link to the actual target specific file.   */
#undef SUPPORT_SUN_FPA
#include "tm.h"

/* If compiled with GNU C, use the built-in alloca */
#ifdef __GNUC__
/* Use an arg in this macro because that's what some other
   system does--let's avoid conflict.  */
#define alloca(x) __builtin_alloca(x)
#endif

/* undefine infomation for dwarf and dwarf2 debugg format */ 
#undef INCOMING_RETURN_ADDR_RTX
#undef DWARF_FRAME_REGNUM
#undef INCOMEING_FRAME_SP_OFFSET 
#undef ARG_POINTER_CFA_OFFSET 

/* Arguments to use with `exit'.  */
#define SUCCESS_EXIT_CODE 0
#define FATAL_EXIT_CODE 33

/* semi colon is default path separator on Human68k */ 
#define PATH_SEPARATOR ';'
/* exec suffix is ".x" on Human68k */ 
#define EXECUTABLE_SUFFIX ".x"

enum x68k_function_type
{
  X68K_FUNC_UNKNOWN, X68K_FUNC_NORMAL, X68K_FUNC_INTERRUPT,
  X68K_FUNC_DOSCALL
};

enum x68k_variable_type
{
  X68K_VAL_UNKNOWN, X68K_VAL_NORMAL, X68K_VAL_COMMON, X68K_VAL_REMOTE, 
  X68K_VAL_RELOCATE
};

extern int interrupt_handler;
extern enum x68k_function_type  x68k_compute_function_type ();
extern enum x68k_variable_type  x68k_compute_variable_type ();
extern int  m68k_valid_machine_decl_attribute ();

#define VALID_MACHINE_DECL_ATTRIBUTE(DECL, ATTRIBUTES, IDENTIFIER, ARGS) \
m68k_valid_machine_decl_attribute (DECL, ATTRIBUTES, IDENTIFIER, ARGS)

/* this is a function type macros */
#define X68K_INTERRUPT_P(DECL) \
(x68k_compute_function_type (DECL) == X68K_FUNC_INTERRUPT)

#define X68K_DOSCALL_P(DECL) \
(x68k_compute_function_type (DECL) == X68K_FUNC_DOSCALL)

/* there are variable type macros */
#define X68K_COMMON_P(DECL) \
(x68k_compute_variable_type (DECL) == X68K_VAL_COMMON)

#define X68K_REMOTE_P(DECL) \
(x68k_compute_variable_type (DECL) == X68K_VAL_REMOTE)

#define X68K_RELOCATE_P(DECL) \
(x68k_compute_variable_type (DECL) == X68K_VAL_RELOCATE)

extern int mariko;     
extern int mariko_frame_pointer;
extern int mariko_forever;
extern unsigned long source_size;
#define MARIKO_D (mariko & 0x8)   /* like tc */

/* change label name character from '.' to '_' */ 
#define NO_DOT_IN_LABEL
/* change label name character from '$' to '_' */ 
#define NO_DOLLAR_IN_LABEL

#ifndef IN_TOPLEV
extern unsigned short parm_boundary;
extern unsigned short parm_boundary_org;
extern unsigned long target_flags_org;
extern unsigned char double_pref_immd;
#endif

#undef PARM_BOUNDARY
#define PARM_BOUNDARY parm_boundary

/* See m68k.h xor all target flag is mc68000  */
#ifndef TARGET_DEFAULT
#define TARGET_DEFAULT -(MASK_5200|MASK_68060|MASK_68040|MASK_68040_ONLY \
                        |MASK_68020|MASK_BITFIELD|MASK_68881)
#endif

#undef CPP_PREDEFINES
#define CPP_PREDEFINES "-Dmc68000 -Dhuman68k -DHUMAN68K -Dmariko_cc=12 -DMARIKO_CC=12 -Asystem(x680x0)  -Asystem(human68k) -Acpu(m68k) -Amachine(m68k)"

#undef TARGET_VERSION
#define TARGET_VERSION fprintf (stderr, " (68k, Human68k SHARP/HAS syntax)");

/* X680x0 's DImode order is little endian */
#undef WORDS_BIG_ENDIAN 
#define WORDS_BIG_ENDIAN 0 

/* Every structure or union's size must be a multiple of 2 bytes */
#define STRUCTURE_SIZE_BOUNDARY 16

/* Override parts of m68k.h */
#undef CALL_USED_REGISTERS
#define CALL_USED_REGISTERS \
 {1, 1, 1, 0, 0, 0, 0, 0,   \
  1, 1, 1, 0, 0, 0, 0, 1,   \
  1, 1, 1, 1, 1, 1, 1, 1 }

#undef PIC_OFFSET_TABLE_REGNUM
#define PIC_OFFSET_TABLE_REGNUM 12

#ifdef __SX_GCC_MODE__
/*  SX GCC for X68000  */ 
extern int flag_sx_fixed;
extern int flag_remote;
#define SX_OFFSET_TABLE_REGNUM 13
#define SX_CALL_RETURN_REG     8
#endif /* __SX_GCC_MODE__ */

extern int flag_no_sx;
extern int flag_text;

#undef FRAME_POINTER_REGNUM
#define FRAME_POINTER_REGNUM mariko_frame_pointer

#undef ARG_POINTER_REGNUM 
#define ARG_POINTER_REGNUM mariko_frame_pointer

#undef MACHINE_STATE_SAVE
#if defined(__mcf5200__)
#define MACHINE_STATE_SAVE(id)		      \
    {					      \
      asm ("sub.l   #28,sp" : );	      \
      asm ("movem.l d0/d1/d2/a0/a1/a2,4(sp)" : ); \
      asm ("move.w  ccr,d0" : );	      \
      asm ("movem.l d0,(sp)" : );	      \
    }
#elif defined(MACHINE_STATE_m68010_up)
#define MACHINE_STATE_SAVE(id)		          \
    {					          \
      asm ("move.w  ccr,-(sp)" : );	          \
      asm ("movem.l d0/d1/d2/a0/a1/a2,-(sp)" : ); \
    }
#else
#define MACHINE_STATE_SAVE(id)		          \
    {					          \
      asm ("move.w  sr,-(sp)" : );	          \
      asm ("movem.l d0/d1/d2/a0/a1/a2,-(sp)" : ); \
    }
#endif

#undef MACHINE_STATE_RESTORE
#if defined(__mcf5200__)
#define MACHINE_STATE_RESTORE(id)	          \
    {					          \
      asm ("movem.l (sp),d0");	                  \
      asm ("move.w d0,ccr");		          \
      asm ("movem.l 4(sp),d0/d1/d2/a0/a1/a2");    \
      asm ("addi.l #28,sp");		          \
    }
#else
#define MACHINE_STATE_RESTORE(id)	          \
    {					          \
      asm ("movem.l (sp)+,d0/d1/d2/a0/a1/a2");    \
      asm ("move.w (sp)+,ccr");		          \
    }
#endif

#undef INITIAL_FRAME_POINTER_OFFSET
#define INITIAL_FRAME_POINTER_OFFSET(DEPTH)			\
{ int regno;                                                    \
  extern interrupt_handler, current_function_is_leaf;           \
  int offset = -4 ;			                        \
  for (regno = 16; regno < FIRST_PSEUDO_REGISTER; regno++)	\
    if ((regs_ever_live[regno] && ! call_used_regs[regno]))     \
      offset += 12;						\
  for (regno = 0; regno < 16; regno++)				\
    if (((regs_ever_live[regno] && ! call_used_regs[regno])	\
        && (regno != STACK_POINTER_REGNUM)                      \
	|| (regs_ever_live[regno] && interrupt_handler)          \
	|| (call_used_regs[regno] && interrupt_handler          \
	    && !current_function_is_leaf))                      \
	    && !global_regs[regno]                              \
	    && !inter_use_regs[regno])                          \
      offset += 4;					        \
  (DEPTH) = (offset + ((get_frame_size () + 3) & -4)		\
	     + (get_frame_size () == 0 ? 0 : 4));		\
}

/* undef uses reentrant convention for returning structure 
    and union values */
#undef PCC_STATIC_STRUCT_RETURN

#define FUNCTION_EXTRA_EPILOGUE(FILE, SIZE)                          \
{ extern int profile_label_no;                                       \
  if (profile_flag)                                                  \
    asm_fprintf (FILE, "\tlea %LLP%d,%Ra2\n\tjsr ___ftime_end\n", (profile_label_no-1));                                                             \
}

/* Override Output at beginning of assembler file */

#undef ASM_FILE_START      	   
#define ASM_FILE_START(FILE)	                                         \
  fprintf (FILE, "* NO_APP\n");                                          

extern unsigned char logmode;
#define ASM_FILE_END(FILE)      \
  fputs ("\t.end\n",FILE);      \
  if (logmode) {                \
    puts ("\n");                \
  }

#define ASM_IDENTIFY_GCC(FILE)               \
  fprintf (FILE, "gcc2_compiled:\n");                          

#define ASM_IDENTIFY_LANGUAGE(FILE)          \
  output_lang_identify (FILE);                          

#undef ASM_APP_ON
#define ASM_APP_ON "* APP ON (APP)\n"

#undef ASM_APP_OFF
#define ASM_APP_OFF "* APP OFF (APP)\n"

/*  for varasm.c  */

#undef TEXT_SECTION_ASM_OP
#define TEXT_SECTION_ASM_OP "\t.text"

#undef DATA_SECTION_ASM_OP
#define DATA_SECTION_ASM_OP "\t.data"

#define BSS_SECTION_ASM_OP  "\t.bss"

#undef EXTRA_SECTIONS
#undef EXTRA_SECTION_FUNCTIONS
#ifdef __SX_GCC_MODE__
#define EXTRA_SECTIONS in_rdata, in_rldata, in_rbss, in_rlbss, in_offset

#define EXTRA_SECTION_FUNCTIONS                          \
                                                         \
void                                                     \
offset_section ()                                        \
{                                                        \
  if (in_section != in_offset)                           \
    {                                                    \
      fputs ("\t.offset\t0\n", asm_out_file);            \
      in_section = in_offset;                            \
    }                                                    \
}                                                        \
                                                         \
void                                                     \
rdata_section ()                                         \
{                                                        \
  if (in_section != in_rdata)                            \
    {                                                    \
      fputs ("\t.rdata\n", asm_out_file);                \
      in_section = in_rdata;                             \
    }                                                    \
}                                                        \
                                                         \
void                                                     \
rldata_section ()                                        \
{                                                        \
  if (in_section != in_rldata)                           \
    {                                                    \
      fputs ("\t.rldata\n", asm_out_file);               \
      in_section = in_rldata;                            \
    }                                                    \
}                                                        \
                                                         \
void                                                     \
rbss_section ()                                          \
{                                                        \
  if (in_section != in_rbss)                             \
    {                                                    \
      fputs ("\t.rbss\n", asm_out_file);                 \
      in_section = in_rbss;                              \
    }                                                    \
}                                                        \
                                                         \
void                                                     \
rlbss_section ()                                         \
{                                                        \
  if (in_section != in_rlbss)                            \
    {                                                    \
      fputs ("\t.rlbss\n", asm_out_file);                \
      in_section = in_rlbss;                             \
    }                                                    \
}

/*extern void x68k_select_section (tree decl, int reloc); */
#undef SELECT_SECTION
#define SELECT_SECTION(DECL,RELOC) x68k_select_section (DECL, RELOC);

#endif /* __SX_GCC_MODE__ */

#undef LOCAL_LABEL_PREFIX
#define LOCAL_LABEL_PREFIX "?"

#undef ASM_GLOBALIZE_LABEL
#define ASM_GLOBALIZE_LABEL(FILE,NAME)	                \
  do { if (strcmp("main", NAME))         		\
        fputs ("\t.globl ", FILE);                      \
       else                                             \
        fputs ("\t.xref __main\n\t.xdef ", FILE);       \
       assemble_name (FILE, NAME);			\
       fputs ("\n", FILE);} while (0)

#undef ASM_OUTPUT_LONG_DOUBLE
#define ASM_OUTPUT_LONG_DOUBLE(FILE,VALUE)  				\
do { long l[3];								\
     REAL_VALUE_TO_TARGET_LONG_DOUBLE (VALUE, l);			\
     fprintf (FILE, "\t.dc.l $%x,$%x,$%x\n", l[0] << 16 , l[1], l[2]);	\
   } while (0)

#undef ASM_OUTPUT_DOUBLE
#define ASM_OUTPUT_DOUBLE(FILE,VALUE)				\
  do { long l[2];						\
       REAL_VALUE_TO_TARGET_DOUBLE (VALUE, l);	                \
       fprintf (FILE, "\t.dc.l $%x,$%x\n", l[0], l[1]);		\
     } while (0)

#undef ASM_OUTPUT_FLOAT
#define ASM_OUTPUT_FLOAT(FILE,VALUE)			\
do { long l;						\
     REAL_VALUE_TO_TARGET_SINGLE (VALUE, l);		\
     fprintf (FILE, "\t.dc.l $%08x\n", l);		\
   } while (0)
     
#undef ASM_OUTPUT_INT
#define ASM_OUTPUT_INT(FILE,VALUE)              \
( fprintf (FILE, "\t.dc.l "),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))
     
#undef ASM_OUTPUT_SHORT
#define ASM_OUTPUT_SHORT(FILE,VALUE)            \
( fprintf (FILE, "\t.dc.w "),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))
     
#undef ASM_OUTPUT_CHAR                          
#define ASM_OUTPUT_CHAR(FILE,VALUE)             \
( fprintf (FILE, "\t.dc.b "),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))

#undef ASM_OUTPUT_BYTE
#define ASM_OUTPUT_BYTE(FILE,VALUE)             \
  fprintf (FILE, "\t.dc.b $%02x\n", (VALUE))
     
#undef ASM_OUTPUT_REG_PUSH
#define ASM_OUTPUT_REG_PUSH(FILE,REGNO)         \
  fprintf (FILE, "\tmove.l %s,-(sp)\n", reg_names[REGNO])
     
#undef ASM_OUTPUT_REG_POP
#define ASM_OUTPUT_REG_POP(FILE,REGNO)  \
  fprintf (FILE, "\tmove.l (sp)+,%s\n", reg_names[REGNO])

#undef ASM_OUTPUT_ADDR_VEC_ELT
#define ASM_OUTPUT_ADDR_VEC_ELT(FILE, VALUE)  \
  fprintf (FILE, "\t.dc.l ?L%d\n", VALUE)
     
#undef ASM_OUTPUT_ADDR_DIFF_ELT
#define ASM_OUTPUT_ADDR_DIFF_ELT(FILE, BODY, VALUE, REL)  \
  fprintf (FILE, "\t.dc.w ?L%d-?L%d\n", VALUE, REL)

#undef ASM_OUTPUT_CASE_FETCH
#define ASM_OUTPUT_CASE_FETCH(FILE, LABELNO, REGNAME) \
	asm_fprintf (FILE, "%LL%d-%LLI%d-2(%Rpc,%s.", LABELNO, LABELNO, REGNAME)
               
#undef ASM_OUTPUT_SKIP
#define ASM_OUTPUT_SKIP(FILE,SIZE)  \
  fprintf (FILE, "\t.ds.b %d\n", (SIZE))

/* This macro is simple. In SX gcc, output section selected
   befor this macro use */

#undef ASM_OUTPUT_COMMON
#ifndef __SX_GCC_MODE__
#define ASM_OUTPUT_COMMON(FILE, NAME, SIZE, ROUNDED)	\
do {                                                    \
      extern int flag_text;                             \
      fputs ("\t.xdef ", (FILE));			\
      assemble_name ((FILE), (NAME));			\
      if (flag_text)					\
        {						\
          fputs("\n",(FILE));				\
          assemble_name ((FILE),(NAME));		\
          fprintf((FILE),":\n\t.ds.b %d\n",(ROUNDED));	\
        }						\
      else						\
       {						\
          if (in_section == in_bss)	         	\
            fputs ("\n\t.comm ", (FILE));		\
          else						\
            abort ();					\
          assemble_name ((FILE), (NAME));		\
          fprintf ((FILE), ",%d\n", (ROUNDED));		\
       }					        \
} while (0)
#else
#define ASM_OUTPUT_COMMON(FILE, NAME, SIZE, ROUNDED)	\
do {                                                    \
      extern int flag_text;                             \
      fputs ("\t.xdef ", (FILE));			\
      assemble_name ((FILE), (NAME));			\
      if (flag_text)					\
        {						\
          fputs("\n",(FILE));				\
          assemble_name ((FILE),(NAME));		\
          fprintf((FILE),":\n\t.ds.b %d\n",(ROUNDED));	\
        }						\
      else						\
       {						\
          if (in_section == in_rbss)			\
            fputs ("\n\t.rcomm ", (FILE));		\
          else if (in_section == in_rlbss)		\
            fputs ("\n\t.rlcomm ", (FILE));		\
          else if (in_section == in_bss)                \
            fputs ("\n\t.comm ", (FILE));		\
          else                                          \
            abort ();                     		\
          assemble_name ((FILE), (NAME));		\
          fprintf ((FILE), ",%d\n", (ROUNDED));		\
     }							\
} while (0)
#endif
/* This says how to output an assembler line
   to define a local common symbol.  */
#define ASM_OUTPUT_BSS(FILE, DECL, NAME, SIZE, ROUNDED) \
  asm_output_bss ((FILE), (DECL), (NAME), (SIZE), (ROUNDED))

#undef ASM_OUTPUT_LOCAL
#define ASM_OUTPUT_LOCAL(FILE, NAME, SIZE, ROUNDED)	        \
 do {                                                           \
    extern int flag_text;                                       \
    if (flag_text)                                              \
      {                                                         \
        text_section();			                        \
        assemble_name ((FILE),(NAME));                          \
        fprintf((FILE),":\n\tds.b %d\n",(ROUNDED));             \
      }                                                         \
   else                                                         \
      {						                \
         assemble_name ((FILE), (NAME));			\
         fprintf ((FILE), ":\n\t.ds.b %d\n", (ROUNDED));	\
      }                                                         \
   } while(0)

#undef ASM_FORMAT_PRIVATE_NAME
#define ASM_FORMAT_PRIVATE_NAME(OUTPUT, NAME, LABELNO)	\
( (OUTPUT) = (char *) alloca (strlen ((NAME)) + 12),	\
  sprintf ((OUTPUT), "?%s_%d", (NAME), (LABELNO)))

#undef ASM_OUTPUT_FLOAT_OPERAND
#define ASM_OUTPUT_FLOAT_OPERAND(CODE,FILE,VALUE)	\
 do {							\
      long l;						\
      REAL_VALUE_TO_TARGET_SINGLE (VALUE, l);		\
        fprintf ((FILE), "#$%x", l);			\
     } while (0)

#undef ASM_OUTPUT_DOUBLE_OPERAND
#define ASM_OUTPUT_DOUBLE_OPERAND(FILE,VALUE)		\
do { long l[2];						\
     REAL_VALUE_TO_TARGET_DOUBLE (VALUE, l);		\
     fprintf (FILE, "#$%08x,#$%08x", l[0], l[1]);	\
   } while (0)

#undef ASM_OUTPUT_LONG_DOUBLE_OPERAND
#define ASM_OUTPUT_LONG_DOUBLE_OPERAND(FILE,VALUE)			\
do { long l[3];								\
     REAL_VALUE_TO_TARGET_LONG_DOUBLE (VALUE, l);			\
       fprintf (FILE, "#$%x,#$%x,#$%x", l[0] << 16 , l[1], l[2]);	\
   } while (0)

/* pragma extention for marikocc */
#define X68K_EXTRA_PRAGMAS

/* X680x0 Extra Macro */
#define X68K_ASM_STACK_CHECK(FILE)           \
   fputs ("___STACK_CHK macro siz\n",FILE);  \
   fputs ("\tmove.l sp,d0\n",FILE);          \
   fputs ("\tsub.l #siz,d0\n",FILE);         \
   if (flag_no_sx)                           \
     fputs ("\tcmp.l __ssta,d0\n",FILE);     \
   else                                      \
     fputs ("\tcmp.l __ssta(a5),d0\n",FILE); \
   fputs ("\t.local OK\n",FILE);             \
   fputs ("\tbge OK\n",FILE);                \
   fputs ("\tjmp __stack_over\n",FILE);      \
   fputs ("OK:\n",FILE);                     \
   fputs ("\tendm\n",FILE);

/* use memcpy(), memcmp(), memset() */
#define TARGET_MEM_FUNCTIONS

#undef ASM_OUTPUT_ASCII(FILE,VALUE,SIZE)
#define ASM_OUTPUT_ASCII(FILE,VALUE,SIZE) \
do {								\
  unsigned char *s = (VALUE);					\
  int i = 0, x = 0, q = 0, c, n;				\
  fputs("\t.dc.b ", (FILE));					\
  for(;;) {							\
    c = *s++;							\
    n = (ISKANJI(c) && ISKANJI2(*s)) ? 2 : (ISPRKANA(c) && c != '\'') ? 1 : 0;	\
    if (n) {							\
      if (q == 0) {						\
	q = 1;							\
        fputc('\'', (FILE));					\
	x++;							\
      }								\
      fputc(c, (FILE));						\
      if (n == 2) {						\
	fputc(*s++, (FILE));					\
	i++;							\
      }								\
      x += n;							\
    }								\
    else {							\
      if (q) {							\
	q = 0;							\
        fputs("',", (FILE));					\
	x += 2;							\
      }								\
      fprintf((FILE), "$%02x", c);				\
      x += 3;							\
    }								\
    if (++i >= (SIZE))						\
      {								\
        if (q)							\
          fputc('\'', (FILE));					\
        break;							\
      }								\
    if (x > 76) {						\
      if (q) {							\
	q = 0;							\
        fputc('\'', (FILE));					\
      }								\
      fputs("\n\t.dc.b ", (FILE));				\
      x = 0;							\
    }								\
    else if (q == 0) {						\
      fputc(',', (FILE));					\
      x++;							\
    }								\
  }								\
  fputc('\n', (FILE));						\
} while(0)

#define ASM_OUTPUT_CONSTRUCTOR(FILE,NAME)		\
      fprintf (FILE, "\t.ctor ");			\
      assemble_name (FILE, NAME);			\
      fputc ('\n', FILE);

#define ASM_OUTPUT_DESTRUCTOR(FILE,NAME)		\
      fprintf (FILE, "\t.dtor ");			\
      assemble_name (FILE, NAME);			\
      fputc ('\n', FILE);

/*   reload1.c  */
#if 0
#define ELIMINABLE_REGS     \
  {{14, STACK_POINTER_REGNUM}}
#endif

/*   varasm.c   */
#define DEFAULT_PCC_STRUCT_RETURN 0

#undef STRIP_NAME_ENCODING
#define STRIP_NAME_ENCODING(VAR,NAME)                   \
do {                                                    \
  char *_name = (char*)alloca (strlen (NAME) + 1);    \
  (VAR) = _name;                                        \
  strcpy (_name,NAME + (NAME[0] == '*'));               \
  while(*_name){                                        \
    if( *_name == '.'                                   \
      || *_name == '+'                                  \
      || *_name == '-'                                  \
      || *_name == '#'                                  \
      || *_name == '&'                                  \
      || *_name == '%'                                  \
      || *_name == '('                                  \
      || *_name == ')'                                  \
      || *_name == '{'                                  \
      || *_name == '}'                                  \
      || *_name == '\\'                                 \
      || *_name == '/'                                  \
      || *_name == ':'                                  \
      || *_name == '^'                                  \
      || *_name == ';'                                  \
      || *_name == '\''                                 \
      || *_name == '!'                                  \
      || *_name == ','                                  \
    ) *_name='_';                                       \
    _name++;                                            \
  }                                                     \
} while (0)                                           

#if 0
#ifndef SWITCH_TAKES_ARG
#define SWITCH_TAKES_ARG(CHAR)      \
  ((CHAR) == 'D' || (CHAR) == 'U' || (CHAR) == 'o' \
   || (CHAR) == 'e' || (CHAR) == 'T' || (CHAR) == 'u' \
   || (CHAR) == 'I' || (CHAR) == 'Y' || (CHAR) == 'm' \
   || (CHAR) == 'L' || (CHAR) == 'i' || (CHAR) == 'A' \
   || (CHAR) == 'B' || (CHAR) == 'b' || (CHAR) == 'x')
#endif
#endif

/* assembler default spec */
#define ASM_SPEC   "-w -u %I"

/* extended spec statement default stack size option */
#define INITIAL_STACK_SIZE	128*1024

/* lk.x spec, but never used */
#define LIB_SPEC ""
/*define LIB_SPEC "%{ldos:libdos.a%s} %{liocs:libiocs.a%s} %{lbas:libbas.a%s}"*/
#define STARTFILE_SPEC ""

#define LINK_COMMAND_SPEC "%{!c:%{!M*:%{!E:%{!S:%{!C:g2lk -1\
 %{z-heap=*:-d_HEAP_SIZE=%zH} %{z-stack=*:-d_STACK_SIZE=%zT}\
 %{v} %{s:-x} %{x} %{b*} %{SX:-s} %l %X %{o*} %{!o*:%{':-o %zL}}\
 %o %L %{!nostdlib:%{!SX:-lc} %{SX:-lgccsx}\
 %{!SX:-lgcc}}\n }}}}}"

#define LINKER_NAME "g2lk"

#define HAVE_DOS_BASED_FILESYSTEM

/* for C preprosessor */
#define INCLUDE_DEFAULTS                              \
{{ "$GPLUSPLUS_INCLUDE", "G++", 1, 1, 0 },            \
 { "$GCC_INCLUDE",       "GCC", 0, 0, 0 },            \
 { "$gcc_include",       "GCC", 0, 0, 0 },            \
 { "$INCLUDE"    ,           0, 0, 0, 0 },            \
 { "$include"    ,           0, 0, 0, 0 },            \
 {              0,           0, 0, 0, 0 }}
  
/* This part is libgcc function */
#ifdef  LIB_GCC_FUNCTION
#define perform_mulsi3(a, b)      \
   asm("move.l	\%0,d0
 	move.l	\%1,d1
	cmp.l	d1,d0
	bcc	mulsi3_skip
	exg.l	d0,d1
mulsi3_skip:
	swap.w	d0
	move.w	d0,d2
	beq	mulsi3_mul0
	swap.w	d0

	swap.w	d1
	tst.w	d1
	beq	mulsi3_mul1

	move.l	d3,-(sp)
	move.w	d0,d3
	mulu.w	d1,d3
	swap.w	d1
	mulu.w	d1,d0
	mulu.w	d1,d2

	swap.w	d0
	add.w	d2,d0
	add.w	d3,d0
	swap.w	d0
	move.l	(sp)+,d3
mulsi3_ret:
	rts

mulsi3_mul0:
	swap.w	d0
	mulu.w	d1,d0
*	bra	mulsi3_ret
	rts

mulsi3_mul1:
	swap.w	d1
	mulu.w	d1,d0
	mulu.w	d1,d2
	swap.w	d0
	add.w	d2,d0
	swap.w	d0
*	bra	mulsi3_ret
" : :"m"(a),"m"(b)); }

#define perform_divsi3(a, b) asm("
	move.l	4(a7),d0
	move.l	8(a7),d1
	bmi	div0
	beq	err

	tst.l	d0
	bpl	udiv

	neg.l	d0
	bsr	udiv
	neg.l	d0
	rts

div0:
	neg.l	d1
	tst.l	d0
	bpl	div1

	neg.l	d0
	bra	udiv

div1:
	bsr	udiv
	neg.l	d0
	rts

___udivsi3::
	move.l	4(a7),d0
	move.l	8(a7),d1
udiv:
	cmp.l	d1,d0
	bcs	nondiv

	cmp.l	#$10000,d1
	bcc	udiv1
err:
	divu.w	d1,d0
	bvs	udiv0

	swap.w	d0
	clr.w	d0
	swap.w	d0

	rts

nondiv:
	moveq.l	#0,d0
	rts

udiv0:
	moveq.l	#0,d2
	swap.w	d0
	move.w	d0,d2
	divu.w	d1,d2
	move.w	d2,d0
	swap.w	d0
	move.w	d0,d2
	divu.w	d1,d2

	move.w	d2,d0
	rts

udiv1:
	move.w	d0,d2
	or.w	d1,d2
	beq	L00014c
	movea.l	d0,a1
	movea.l	d1,a2
	move.l	d1,d2
	swap.w	d2
	cmp.l	#$01000000,d1
	bcc	L0001a8
	move.b	L0001d8(pc,d2.w),d2
	bra	L0001b8
L0001a8:
	lsr.w	#8,d2
	move.b	L0001d8(pc,d2.w),d2
	addq.w	#8,d2
L0001b8:
	lsr.l	d2,d1
	lsr.l	d2,d0
	divu.w	d1,d0
	swap.w	d0
	clr.w	d0
	swap.w	d0
	move.l	d0,d2
	move.l	a2,d1
	mulu.w	d1,d2
	swap.w	d1
	mulu.w	d0,d1
	swap.w	d1
	clr.w	d1
	add.l	d1,d2
	cmp.l	a1,d2
	bls	L0001d6
	subq.l	#1,d0
L0001d6:
	rts

L0001d8:
	.dc.b	$00,$01,$02,$02,$03,$03,$03,$03
	.dc.b	$04,$04,$04,$04,$04,$04,$04,$04
	.dc.b	$05,$05,$05,$05,$05,$05,$05,$05
	.dc.b	$05,$05,$05,$05,$05,$05,$05,$05
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
L00014c:
	swap.w	d0
	swap.w	d1
	divu.w	d1,d0
	swap.w	d0
	clr.w	d0
	swap.w	d0
*	rts
");

#define perform_udivsi3(a, b) asm("
");
#if 0
	move.l	\%0,d0
	move.l	\%1,d1

	tst.l	d1
	beq	udivsi3_retn

udivsi3_udiv:
	.xref	divsi3_udiv1
	.xref	divsi3_udiv0
	cmp.l	#$10000,d1
	bcc	divsi3_udiv1
	divu.w	d1,d0
	bvs	divsi3_udiv0

	swap.w	d0
	clr.w	d0
	swap.w	d0
udivsi3_retn:
*	rts
"" : :"m"(a),"m"(b));
#endif

#define perform_modsi3(a, b) asm("
	move.l	4(a7),d0
	move.l	8(a7),d1
	bmi	div0
	beq	err

	tst.l	d0
	bpl	udiv

	neg.l	d0
	bsr	udiv
	neg.l	d0
	rts

div0:
	neg.l	d1
	tst.l	d0
	bpl	div1

	neg.l	d0
	bsr	udiv
	neg.l	d0
	rts


___umodsi3::
	move.l	4(a7),d0
	move.l	8(a7),d1
div1:
udiv:
	cmp.l	d1,d0
	bcs	nondiv

	cmp.l	#$10000,d1
	bcc	udiv1
err:
	divu.w	d1,d0
	bvs	udiv0

	clr.w	d0
	swap.w	d0
nondiv:
	rts

udiv0:
	moveq.l	#0,d2
	swap.w	d0
	move.w	d0,d2
	divu.w	d1,d2
	move.w	d2,d0
	swap.w	d0
	move.w	d0,d2
	divu.w	d1,d2

	moveq.l #0,d0
	swap.w	d2
	move.w	d2,d0
	rts

udiv1:
	move.w	d0,d2
	or.w	d1,d2
	beq	L000156
	movea.l	d0,a1
	movea.l	d1,a2
	cmp.l	#$01000000,d1
	move.l	d1,d2
	swap.w	d2
	bcc	L000198
	move.b	L0001c4(pc,d2.w),d2
	bra	L0001a8
L000198:
	lsr.w	#8,d2
	move.b	L0001c4(pc,d2.w),d2
	addq.w	#8,d2
L0001a8:
	lsr.l	d2,d1
	lsr.l	d2,d0
	divu.w	d1,d0
	move.w	d0,d2
	move.l	a2,d1
	mulu.w	d1,d2
	swap.w	d1
	mulu.w	d0,d1
	swap.w	d1
	clr.w	d1
	add.l	d1,d2
	move.l	a1,d0
	sub.l	d2,d0
	bpl	L0001c2
	add.l	a2,d0
L0001c2:
	rts

L0001c4:
	.dc.b	$00,$01,$02,$02,$03,$03,$03,$03
	.dc.b	$04,$04,$04,$04,$04,$04,$04,$04
	.dc.b	$05,$05,$05,$05,$05,$05,$05,$05
	.dc.b	$05,$05,$05,$05,$05,$05,$05,$05
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$06,$06,$06,$06,$06,$06,$06,$06
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$07,$07,$07,$07,$07,$07,$07,$07
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
	.dc.b	$08,$08,$08,$08,$08,$08,$08,$08
L000156:
	swap.w	d0
	swap.w	d1
	divu.w	d1,d0
	clr.w	d0
*	rts
");

#define perform_umodsi3(a, b) asm("
");
#if 0
"	move.l	\%0,d1
	move.l	\%1,d0

	tst.l	d0
	.xref	modsi3_udiv
	bne	modsi3_udiv
*	beq	umodsi3_retn
" : :"m"(a),"m"(b));
#endif

#define perform_adddf3(a, b) asm("
	.include fefunc.h
	move.l	(a7)+,a0
	FPACK	__CDADD
	move.l	(a7),d0
	move.l	$0004(a7),d1
	jmp	(a0)
" : : );

#define perform_subdf3(a, b) asm("
	.include fefunc.h
	movea.l	(a7)+,a0
	FPACK	__CDSUB
	move.l	(a7),d0
	move.l	$0004(a7),d1
	jmp	(a0)
" : : );

#define perform_muldf3(a, b) asm("
	.include fefunc.h
	movea.l	(a7)+,a0
	FPACK	__CDMUL
	move.l	(a7),d0
	move.l	$0004(a7),d1
	jmp	(a0)
" : : );

#define perform_divdf3(a, b) asm("
	.include fefunc.h
	movea.l	(a7)+,a0
	FPACK	__CDDIV
	move.l	(a7),d0
	move.l	$0004(a7),d1
	jmp	(a0)
" : : );

#define perform_addsf3(a, b) asm("
	.include fefunc.h
	movem.l	$0004(a7),d0-d1
L00076e:
	movea.l	d3,a0
	movea.l	d4,a1
	move.w	#$7f80,d2
	move.l	d0,d3
	swap.w	d3
	and.w	d2,d3
	beq	L000a34
	move.l	d1,d4
	swap.w	d4
	and.w	d2,d4
	beq	L000a46
	move.w	d4,d2
	sub.w	d3,d4
	beq	L0007ae
	bpl	L0007a0
	cmp.w	#$f180,d4
	bcs	L000a46
	neg.w	d4
	asr.w	#7,d4
	bra	L0007ae
L0007a0:
	cmp.w	#$0e80,d4
	bhi	L000a44
	move.w	d2,d3
	exg.l	d0,d1
	asr.w	#7,d4
L0007ae:
	move.l	#$007fffff,d2
	tst.l	d1
	bmi	L0007c4
	and.l	d2,d1
	bset.l	#$17,d1
	add.l	d1,d1
	lsr.l	d4,d1
	bra	L0007d0
L0007c4:
	and.l	d2,d1
	bset.l	#$17,d1
	add.l	d1,d1
	lsr.l	d4,d1
	neg.l	d1
L0007d0:
	tst.l	d0
	bmi	L0007de
	and.l	d2,d0
	bset.l	#$17,d0
	add.l	d0,d0
	bra	L0007e8
L0007de:
	and.l	d2,d0
	bset.l	#$17,d0
	add.l	d0,d0
	neg.l	d0
L0007e8:
	add.l	d1,d0
	beq	L000a4c
	move.l	d0,d4
	bpl	L0007f4
	neg.l	d0
L0007f4:
	swap.w	d0
	tst.w	d0
	bne	L00095a
	swap.w	d0
	cmp.w	#$00ff,d0
	bhi	L0008b4
	cmp.w	#$000f,d0
	bhi	L000864
	cmp.w	#$0003,d0
	bhi	L00083e
	cmp.w	#$0001,d0
	bhi	L00082e
	bcs	L000a46
	moveq.l	#$00,d0
	bset.l	#$17,d0
	sub.w	#$0c00,d3
	bls	L000a4c
	bra	L000a10
L00082e:
	swap.w	d0
	lsl.l	#6,d0
	sub.w	#$0b80,d3
	bls	L000a4c
	bra	L000a10
L00083e:
	btst.l	#$03,d0
	bne	L000854
	swap.w	d0
	lsl.l	#5,d0
	sub.w	#$0b00,d3
	bls	L000a4c
	bra	L000a10
L000854:
	swap.w	d0
	lsl.l	#4,d0
	sub.w	#$0a80,d3
	bls	L000a4c
	bra	L000a10
L000864:
	cmp.w	#$003f,d0
	bhi	L000890
	btst.l	#$05,d0
	bne	L000880
	swap.w	d0
	lsl.l	#3,d0
	sub.w	#$0a00,d3
	bls	L000a4c
	bra	L000a10
L000880:
	swap.w	d0
	lsl.l	#2,d0
	sub.w	#$0980,d3
	bls	L000a4c
	bra	L000a10
L000890:
	btst.l	#$07,d0
	bne	L0008a6
	swap.w	d0
	add.l	d0,d0
	sub.w	#$0900,d3
	bls	L000a4c
	bra	L000a10
L0008a6:
	swap.w	d0
	sub.w	#$0880,d3
	bls	L000a4c
	bra	L000a10
L0008b4:
	cmp.w	#$0fff,d0
	bhi	L00090c
	cmp.w	#$03ff,d0
	bhi	L0008e6
	btst.l	#$09,d0
	bne	L0008d6
	swap.w	d0
	lsr.l	#1,d0
	sub.w	#$0800,d3
	bls	L000a4c
	bra	L000a10
L0008d6:
	swap.w	d0
	lsr.l	#2,d0
	sub.w	#$0780,d3
	bls	L000a4c
	bra	L000a10
L0008e6:
	btst.l	#$0b,d0
	bne	L0008fc
	swap.w	d0
	lsr.l	#3,d0
	sub.w	#$0700,d3
	bls	L000a4c
	bra	L000a10
L0008fc:
	swap.w	d0
	lsr.l	#4,d0
	sub.w	#$0680,d3
	bls	L000a4c
	bra	L000a10
L00090c:
	cmp.w	#$3fff,d0
	bhi	L000938
	btst.l	#$0d,d0
	bne	L000928
	swap.w	d0
	lsr.l	#5,d0
	sub.w	#$0600,d3
	bls	L000a4c
	bra	L000a10
L000928:
	swap.w	d0
	lsr.l	#6,d0
	sub.w	#$0580,d3
	bls	L000a4c
	bra	L000a10
L000938:
	tst.w	d0
	bmi	L00094c
	swap.w	d0
	lsr.l	#7,d0
	sub.w	#$0500,d3
	bls	L000a4c
	bra	L000a10
L00094c:
	lsl.l	#8,d0
	sub.w	#$0480,d3
	bls	L000a4c
	bra	L000a10
L00095a:
	cmp.w	#$00ff,d0
	bhi	L0009f6
	cmp.w	#$000f,d0
	bhi	L0009b4
	cmp.w	#$0003,d0
	bhi	L000992
	btst.l	#$01,d0
	bne	L000984
	swap.w	d0
	lsl.l	#7,d0
	sub.w	#$0400,d3
	bls	L000a4c
	bra	L000a10
L000984:
	swap.w	d0
	lsl.l	#6,d0
	sub.w	#$0380,d3
	bls	L000a4c
	bra	L000a10
L000992:
	btst.l	#$03,d0
	bne	L0009a6
	swap.w	d0
	lsl.l	#5,d0
	sub.w	#$0300,d3
	bls	L000a4c
	bra	L000a10
L0009a6:
	swap.w	d0
	lsl.l	#4,d0
	sub.w	#$0280,d3
	bls	L000a4c
	bra	L000a10
L0009b4:
	cmp.w	#$003f,d0
	bhi	L0009da
	btst.l	#$05,d0
	bne	L0009ce
	swap.w	d0
	lsl.l	#3,d0
	sub.w	#$0200,d3
	bls	L000a4c
	bra	L000a10
L0009ce:
	swap.w	d0
	lsl.l	#2,d0
	sub.w	#$0180,d3
	bls	L000a4c
	bra	L000a10
L0009da:
	btst.l	#$07,d0
	bne	L0009ec
	swap.w	d0
	add.l	d0,d0
	sub.w	#$0100,d3
	bls	L000a4c
	bra	L000a10
L0009ec:
	swap.w	d0
	sub.w	#$0080,d3
	bls	L000a4c
	bra	L000a10
L0009f6:
	btst.l	#$09,d0
	bne	L000a02
	swap.w	d0
	lsr.l	#1,d0
	bra	L000a10
L000a02:
	swap.w	d0
	lsr.l	#2,d0
	add.w	#$0080,d3
	bmi	L000a54
	bra.w	L000a10
L000a10:
	and.l	d2,d0
	swap.w	d0
	or.w	d3,d0
	swap.w	d0
	tst.l	d4
	bpl	L000a46
	bset.l	#$1f,d0
	move.l	a1,d4
	move.l	a0,d3
	rts
L000a34:
	move.l	d1,d0
	swap.w	d1
	and.w	#$7f80,d1
	beq	L000a4c
	move.l	a1,d4
	move.l	a0,d3
	rts

L000a44:
	move.l	d1,d0
L000a46:
	move.l	a1,d4
	move.l	a0,d3
	rts

L000a4c:
	moveq.l	#$00,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

___subsf3::
	movem.l	$0004(a7),d0-d1
	bchg.l	#$1f,d1
	bra	L00076e

L000a54:
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0
	move.l	a1,d4
	move.l	a0,d3
*	rts
" : : );

#define perform_subsf3(a, b) asm("
" : : );

#define perform_mulsf3(a, b) asm("
	.include fefunc.h
	movem.l	$0004(a7),d0-d1
	movea.l	d3,a0
	movea.l	d4,a1
	movea.l	d5,a2
	move.w	#$7f80,d2
	move.l	d0,d3
	swap.w	d3
	and.w	d2,d3
	beq.s	L000bb6
	move.l	d1,d4
	swap.w	d4
	and.w	d2,d4
	beq	L000bb6
	sub.w	#$3f80,d3
	add.w	d4,d3
	bvs	L000bc0
	move.l	d0,d4
	eor.l	d1,d4
	move.l	#$007fffff,d2
	and.l	d2,d0
	lsl.l	#8,d0
	bset.l	#$1f,d0
	and.l	d2,d1
	lsl.l	#8,d1
	bset.l	#$1f,d1
	move.l	d0,d2
	swap.w	d2
	mulu.w	d1,d2
	swap.w	d1
	move.w	d1,d5
	mulu.w	d0,d5
	clr.w	d5
	swap.w	d5
	clr.w	d2
	swap.w	d2
	add.l	d5,d2
	swap.w	d0
	mulu.w	d1,d0
	add.l	d2,d0
	moveq.l	#$00,d1
	tst.l	d0
	bmi	L000b8c
	lsr.l	#7,d0
	tst.w	d3
	ble	L000bb6
	bra	L000b96
L000b8c:
	add.w	#$0080,d3
	bvs	L000bd4
	ble	L000bb6
	lsr.l	#8,d0
L000b96:
	and.l	#$007fffff,d0
	swap.w	d0
	or.w	d3,d0
	swap.w	d0
	tst.l	d4
	bpl	L000baa
	bset.l	#$1f,d0
L000baa:
	move.l	a2,d5
	move.l	a1,d4
	move.l	a0,d3
	rts

L000bb2:
	moveq.l	#$00,d0
	rts

L000bb6:
	moveq.l	#$00,d0
	move.l	a2,d5
	move.l	a1,d4
	move.l	a0,d3
	rts

L000bc0:
	eor.l	d0,d1
	move.l	#$ff000000,d0
	add.l	d1,d1
	roxr.l	#1,d0
	move.l	a2,d5
	move.l	a1,d4
	move.l	a0,d3
	rts

L000bd4:
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0
	move.l	a2,d5
	move.l	a1,d4
	move.l	a0,d3
*	rts
" : : );

#define perform_divsf3(a, b) asm("
	.include fefunc.h
	movem.l	$0004(a7),d0-d1
	movea.l	d3,a0
	movea.l	d4,a1
	move.w	#$7f80,d2
	move.l	d1,d4
	swap.w	d4
	and.w	d2,d4
	beq	L000afc
	move.l	d0,d3
	swap.w	d3
	and.w	d2,d3
	beq	L000b18
	sub.w	d4,d3
	add.w	#$3f80,d3
	blt	L000b18
	move.l	d0,d4
	eor.l	d1,d4
	move.l	#$007fffff,d2
	and.l	d2,d0
	lsl.l	#7,d0
	bset.l	#$1e,d0
	and.l	d2,d1
	lsl.l	#8,d1
	bset.l	#$1f,d1
	movea.l	d5,a2
	move.l	d0,d5
	swap.w	d5
	mulu.w	d1,d5
	swap.w	d1
	divu.w	d1,d5
	and.l	#$0000ffff,d5
	sub.l	d5,d0
	divu.w	d1,d0
	move.l	d0,d5
	clr.w	d5
	divu.w	d1,d5
	swap.w	d0
	move.w	d5,d0
	move.l	a2,d5
	moveq.l	#$00,d1
	tst.l	d0
	bmi	L000ade
	sub.w	#$0080,d3
	bls	L000b18
	bmi	L000b08
	lsr.l	#7,d0
	bra	L000ae6
L000ade:
	tst.w	d3
	beq	L000b18
	bmi	L000b08
	lsr.l	#8,d0
L000ae6:
	and.l	d2,d0
	swap.w	d0
	or.w	d3,d0
	swap.w	d0
	tst.l	d4
	bpl	L000af6
	bset.l	#$1f,d0
L000af6:
	move.l	a1,d4
	move.l	a0,d3
	rts

L000afc:
	move.l	#$7fffffff,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

L000b08:
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

L000b18:
	moveq.l	#$00,d0
	move.l	a1,d4
	move.l	a0,d3
*	rts
" : : );

#define perform_negdf2(a) asm("
	movem.l  4(a7),d0-d1
	move.l	d0,d2
	or.l	d1,d2
	beq	L000364
	bchg.l	#$1f,d0
L000364:
*	rts
" : : );

#define perform_negsf2(a) asm("
	move.l	$0004(a7),d0
	bchg.l	#$1f,d0
*	rts
" : : );

#define perform_fixdfsi(a) asm("
	movem.l	$0004(a7),d0-d1
	move.l	d0,d2
	or.l	d1,d2
	beq	L0003b6
	swap.w	d0
	move.w	d0,d2
	movea.w	d0,a2
	and.w	#$000f,d0
	or.w	#$0010,d0
	swap.w	d0
	and.w	#$7ff0,d2
	sub.w	#$3ff0,d2
	bmi	L0003b6
	lsr.w	#4,d2
	sub.w	#$0014,d2
	bmi	L0003aa
	beq	L0003ae
	cmp.w	#$000a,d2
	bhi	L0003ba
	move.w	d0,d1
	swap.w	d1
	lsl.l	d2,d0
	lsl.l	d2,d1
	swap.w	d1
	move.w	d1,d0
	bra	L0003ae
L0003aa:
	neg.w	d2
	lsr.l	d2,d0
L0003ae:
	move.w	a2,d2
	bpl	L0003b4
	neg.l	d0
L0003b4:
	rts

L0003b6:
	moveq.l	#$00,d0
	rts

L0003ba:
	move.l	a2,d0
	bpl	L0003c6
	move.l	#$80000000,d0
	rts

L0003c6:
	move.l	#$7fffffff,d0
*	rts
" : : );

#define perform_fixsfsi(a) asm("
	.include fefunc.h
	move.l	$0004(a7),-(a7)
	jsr	___extendsfdf2
	addq.w	#4,a7
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	___fixdfsi
	addq.w	#8,a7
*	rts
" : : );

#define perform_floatsidf(a) asm("
	.include fefunc.h
	move.l	$0004(a7),d0
	movea.l	d0,a0
	bpl	L0003d8
	neg.l	d0
L0003d8:
	moveq.l	#$00,d1
	swap.w	d0
	tst.w	d0
	bne	L000542
	swap.w	d0
	cmp.w	#$00ff,d0
	bhi	L000494
	cmp.w	#$000f,d0
	bhi	L000444
	cmp.w	#$0003,d0
	bhi	L00041e
	cmp.w	#$0001,d0
	bhi	L00040c
	bcs	L000714
	move.l	#$3ff00000,d0
	bra	L00070c
L00040c:
	moveq.l	#$00,d1
	lsl.w	#3,d0
	and.w	#$000f,d0
	or.w	#$4000,d0
	swap.w	d0
	bra	L00070c
L00041e:
	btst.l	#$03,d0
	bne	L000432
	moveq.l	#$00,d1
	lsl.w	#2,d0
	or.w	#$4010,d0
	swap.w	d0
	bra	L00070c
L000432:
	moveq.l	#$00,d1
	add.w	d0,d0
	and.w	#$000f,d0
	or.w	#$4020,d0
	swap.w	d0
	bra	L00070c
L000444:
	cmp.w	#$003f,d0
	bhi	L00046e
	btst.l	#$05,d0
	bne	L00045c
	moveq.l	#$00,d1
	or.w	#$4030,d0
	swap.w	d0
	bra	L00070c
L00045c:
	moveq.l	#$00,d1
	and.w	#$001f,d0
	or.w	#$8080,d0
	swap.w	d0
	lsr.l	#1,d0
	bra	L00070c
L00046e:
	btst.l	#$07,d0
	bne	L000482
	moveq.l	#$00,d1
	ror.l	#2,d0
	or.w	#$4050,d0
	swap.w	d0
	bra	L00070c
L000482:
	moveq.l	#$00,d1
	ror.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4060,d0
	swap.w	d0
	bra	L00070c
L000494:
	cmp.w	#$0fff,d0
	bhi	L0004ec
	cmp.w	#$03ff,d0
	bhi	L0004c6
	btst.l	#$09,d0
	bne	L0004b4
	moveq.l	#$00,d1
	ror.l	#4,d0
	or.w	#$4070,d0
	swap.w	d0
	bra	L00070c
L0004b4:
	moveq.l	#$00,d1
	ror.l	#5,d0
	and.w	#$000f,d0
	or.w	#$4080,d0
	swap.w	d0
	bra	L00070c
L0004c6:
	btst.l	#$0b,d0
	bne	L0004da
	moveq.l	#$00,d1
	ror.l	#6,d0
	or.w	#$4090,d0
	swap.w	d0
	bra	L00070c
L0004da:
	moveq.l	#$00,d1
	ror.l	#7,d0
	and.w	#$000f,d0
	or.w	#$40a0,d0
	swap.w	d0
	bra	L00070c
L0004ec:
	cmp.w	#$3fff,d0
	bhi	L00051a
	btst.l	#$0d,d0
	bne	L000506
	moveq.l	#$00,d1
	ror.l	#8,d0
	or.w	#$40b0,d0
	swap.w	d0
	bra	L00070c
L000506:
	moveq.l	#$00,d1
	lsl.l	#7,d0
	swap.w	d0
	and.w	#$000f,d0
	or.w	#$40c0,d0
	swap.w	d0
	bra	L00070c
L00051a:
	tst.w	d0
	bmi	L00052e
	moveq.l	#$00,d1
	lsl.l	#6,d0
	swap.w	d0
	or.w	#$40d0,d0
	swap.w	d0
	bra	L00070c
L00052e:
	moveq.l	#$00,d1
	lsl.l	#5,d0
	swap.w	d0
	and.w	#$000f,d0
	or.w	#$40e0,d0
	swap.w	d0
	bra	L00070c
L000542:
	cmp.w	#$00ff,d0
	bhi	L00060c
	cmp.w	#$000f,d0
	bhi	L0005a2
	cmp.w	#$0003,d0
	bhi	L00057c
	btst.l	#$01,d0
	bne	L00056a
	moveq.l	#$00,d1
	move.w	#$040f,d0
	swap.w	d0
	lsl.l	#4,d0
	bra	L00070c
L00056a:
	moveq.l	#$00,d1
	rol.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4100,d0
	swap.w	d0
	bra	L00070c
L00057c:
	btst.l	#$03,d0
	bne	L000590
	moveq.l	#$00,d1
	rol.l	#2,d0
	or.w	#$4110,d0
	swap.w	d0
	bra	L00070c
L000590:
	moveq.l	#$00,d1
	rol.l	#1,d0
	and.w	#$000f,d0
	or.w	#$4120,d0
	swap.w	d0
	bra	L00070c
L0005a2:
	cmp.w	#$003f,d0
	bhi	L0005ce
	btst.l	#$05,d0
	bne	L0005ba
	moveq.l	#$00,d1
	or.w	#$4130,d0
	swap.w	d0
	bra	L00070c
L0005ba:
	moveq.l	#$00,d1
	and.w	#$001f,d0
	or.w	#$8280,d0
	swap.w	d0
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	L00070c
L0005ce:
	btst.l	#$07,d0
	bne	L0005ee
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#2,d1
	move.b	d1,d0
	or.w	#$4150,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L0005ee:
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#3,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4160,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L00060c:
	cmp.w	#$0fff,d0
	bhi	L000694
	cmp.w	#$03ff,d0
	bhi	L000658
	btst.l	#$09,d0
	bne	L00063a
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#4,d1
	move.b	d1,d0
	or.w	#$4170,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L00063a:
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#5,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4180,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L000658:
	btst.l	#$0b,d0
	bne	L000678
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#6,d1
	move.b	d1,d0
	or.w	#$4190,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L000678:
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#7,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$41a0,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L000694:
	cmp.w	#$3fff,d0
	bhi	L0006d2
	btst.l	#$0d,d0
	bne	L0006b8
	move.l	d0,d1
	moveq.l	#$00,d0
	ror.l	#8,d1
	move.b	d1,d0
	or.w	#$41b0,d0
	clr.b	d1
	swap.w	d1
	swap.w	d0
	move.w	d1,d0
	clr.w	d1
	bra	L00070c
L0006b8:
	swap.w	d0
	rol.l	#7,d0
	move.l	d0,d1
	and.w	#$ff80,d1
	and.w	#$000f,d0
	or.w	#$41c0,d0
	swap.w	d0
	swap.w	d1
	clr.w	d1
	bra	L00070c
L0006d2:
	tst.w	d0
	bmi	L0006f0
	swap.w	d0
	rol.l	#6,d0
	move.l	d0,d1
	and.w	#$ffc0,d1
	and.w	#$000f,d0
	or.w	#$41d0,d0
	swap.w	d0
	swap.w	d1
	clr.w	d1
	bra	L00070c
L0006f0:
	swap.w	d0
	rol.l	#5,d0
	move.l	d0,d1
	and.w	#$ffe0,d1
	and.w	#$000f,d0
	or.w	#$41e0,d0
	swap.w	d0
	swap.w	d1
	clr.w	d1
L00070c:
	move.l	a0,d2
	bpl	L000714
	bset.l	#$1f,d0
L000714:
*	rts
" : : );

#define perform_floatsisf(a) asm("
	.include fefunc.h
	move.l	$0004(a7),-(a7)
	jsr	___floatsidf
*	addq.w	#4,a7
	move.l	d1,(a7)
	move.l	d0,-(a7)
	jsr	___truncdfsf2
	addq.w	#8,a7
*	rts
" : : );

#define perform_extendsfdf2(a) asm("
	.include fefunc.h
	move.l	$0004(a7),d0
	move.l	d0,d1
	swap.w	d1
	and.w	#$7f80,d1
	beq	L000744
	cmp.w	#$7f80,d1
	beq	L00074a
*	move.l	d0,d1
	asr.l	#3,d0
	swap.w	d0
	and.w	#$8fff,d0
	add.w	#$3800,d0
	swap.w	d0
	ror.l	#3,d1
	and.l	#$e0000000,d1
	rts

L000744:
	moveq.l	#$00,d0
	move.l	d0,d1
	rts

L00074a:
	swap.w	d1
	and.l	#$007fffff,d1
	bne	L00075e
	or.l	#$7ff00000,d0
	moveq.l	#$00,d0
	rts

L00075e:
	or.l	#$7fffffff,d0
	moveq.l	#$ff,d1
*	rts
" : : );

#define perform_truncdfsf2(a) asm("
	.include fefunc.h
	movem.l	$0004(a7),d0-d1
	swap.w	d0
	move.w	d0,d2
	and.w	#$7ff0,d2
	sub.w	#$3800,d2
	bls	L000c24
	cmp.w	#$0ff0,d2
	bcc	L000c2e
	move.w	d0,d1
	and.w	#$8000,d1
	and.w	#$000f,d0
	or.w	d2,d0
	rol.l	#3,d0
	or.w	d1,d0
	swap.w	d0
	clr.w	d1
	rol.l	#3,d1
	or.w	d1,d0
	rts

L000c24:
	swap.w	d0
	and.l	#$80000000,d0
	rts

L000c2e:
	cmp.w	#$47f0,d2
	bne	L000c40
	move.l	d0,d2
	and.l	#$ffff000f,d2
	or.l	d1,d2
	bne	L000c4e
L000c40:
	and.w	#$8000,d0
	or.w	#$7f80,d0
	swap.w	d0
	clr.w	d0
	rts

L000c4e:
	or.l	#$ffff7fff,d0
	swap.w	d0
*	rts
" : : );

/* Note that eqdf2 returns a value for "true" that is == 0,
   nedf2 returns a value for "true" that is != 0,
   gtdf2 returns a value for "true" that is > 0,
   and so on.  */

#define perform_eqdf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d1
	move.l	$000c(a7),d2
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	sne.b	d0
	moveq.l	#$01,d3
	and.l	d3,d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_nedf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d1
	move.l	$000c(a7),d2
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	sne.b	d0
	moveq.l	#$01,d3
	and.l	d3,d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_gtdf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d1
	move.l	$000c(a7),d2
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	sgt.b	d0
	moveq.l	#$01,d3
	and.l	d3,d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_gedf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d1
	move.l	$000c(a7),d2
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	sge.b	d0
	moveq.l	#$01,d3
	and.l	d3,d0
	subq.l	#1,d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_ltdf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d1
	move.l	$000c(a7),d2
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d2,-(a7)
	move.l	d1,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	slt.b	d0
	moveq.l	#$01,d3
	and.l	d3,d0
	neg.l	d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_ledf2(a, b) asm("
	move.l	d3,-(a7)
	move.l	$0008(a7),d0
	move.l	$000c(a7),d1
	moveq.l	#$01,d3
	move.l	$0014(a7),-(a7)
	move.l	$0014(a7),-(a7)
	move.l	d1,-(a7)
	move.l	d0,-(a7)
	jsr	___cmpdf2
	lea.l	$0010(a7),a7
	tst.l	d0
	bgt	L00026c
	moveq.l	#$00,d3
L00026c:
	move.l	d3,d0
	move.l	(a7)+,d3
*	rts
" : : );

#define perform_eqsf2(a, b) asm("
	move.l	$0004(a7),d1
	move.l	$0008(a7),-(a7)
	move.l	d1,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	sne.b	d0
	moveq.l	#$01,d2
	and.l	d2,d0
*	rts
" : : );

#define perform_nesf2(a, b) asm("
	move.l	$0004(a7),d1
	move.l	$0008(a7),-(a7)
	move.l	d1,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	sne.b	d0
	moveq.l	#$01,d2
	and.l	d2,d0
*	rts
" : : );

#define perform_gtsf2(a, b) asm("
	move.l	$0004(a7),d1
	move.l	$0008(a7),-(a7)
	move.l	d1,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	sgt.b	d0
	moveq.l	#$01,d2
	and.l	d2,d0
*	rts
" : : );

#define perform_gesf2(a, b) asm("
	move.l	$0004(a7),d1
	move.l	$0008(a7),-(a7)
	move.l	d1,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	sge.b	d0
	moveq.l	#$01,d2
	and.l	d2,d0
	subq.l	#1,d0
*	rts
" : : );

#define perform_ltsf2(a, b) asm("
	move.l	$0004(a7),d1
	move.l	$0008(a7),-(a7)
	move.l	d1,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	slt.b	d0
	moveq.l	#$01,d2
	and.l	d2,d0
	neg.l	d0
*	rts
" : : );

#define perform_lesf2(a, b) asm("
	.include	doscall.mac
	.include	fefunc.h
	move.l	d3,-(a7)
	move.l	$0008(a7),d0
	moveq.l	#$01,d3
	move.l	$000c(a7),-(a7)
	move.l	d0,-(a7)
	jsr	___cmpsf2
	addq.w	#8,a7
	tst.l	d0
	bgt	L00031e
	moveq.l	#$00,d3
L00031e:
	move.l	d3,d0
	move.l	(a7)+,d3
	rts

___cmpdf2::
	movem.l	d3-d7,-(a7)
	move.l	$0018(a7),d6
	move.l	$001c(a7),d7
	move.l	$0020(a7),d4
	move.l	$0024(a7),d5
	btst.b	#$00,__havefpu
	beq	L000dd8
	btst.b	#$01,__havefpu
	bne	L000dac
	move.w	sr,d0
	btst.l	#$0d,d0
	beq	L000dac
	moveq.l	#$00,d3
	bra	L000db6
L000dac:
	pea.l	0.w
	DOS	__SUPER
	addq.w	#4,a7
	move.l	d0,d3
L000db6:
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	bsr	__fpu_cmpdf2
	lea.l	$0010(a7),a7
	move.l	d0,d2
	tst.l	d3
	ble	L000e04
	move.l	a7,d1
	movea.l	d3,a7
	andi.w	#$dfff,sr
	movea.l	d1,a7
	bra	L000e04
L000dd8:
	btst.b	#$02,__havefpu
	beq	L000df2
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	jsr	__f_cmpdf2
	bra	L000dfe
L000df2:
	move.l	d5,-(a7)
	move.l	d4,-(a7)
	move.l	d7,-(a7)
	move.l	d6,-(a7)
	bsr	__fe_cmpdf2
L000dfe:
	lea.l	$0010(a7),a7
	move.l	d0,d2
L000e04:
	move.l	d2,d0
	movem.l	(a7)+,d3-d7
	rts

___cmpsf2::
	move.l	$0004(a7),d0
	bmi	L000e1c
	move.l	$0008(a7),d1
	bmi	L000e2c
	sub.l	d1,d0
	rts

L000e1c:
	bclr.l	#$1f,d0
	move.l	$0008(a7),d1
	bmi	L000e34
	or.l	d1,d0
	neg.l	d0
	rts

L000e2c:
	bclr.l	#$1f,d1
	or.l	d1,d0
	rts

L000e34:
	bclr.l	#$1f,d1
	sub.l	d1,d0
	neg.l	d0
	rts

L000e3e:
	movem.l	d0-d2/a0-a2,-(a7)
	moveq.l	#$00,d0
	move.l	d0,L000f6a
	movem.l	(a7)+,d0-d2/a0-a2
	rte

L000e50:
*	link	a6,#0
	movem.l	d3-d4,-(a7)
	moveq.l	#$01,d1
	move.l	d1,L000f6a
	pea.l	L000e3e(pc)
	moveq.l	#$08,d3
	move.w	d3,-(a7)
	DOS	__INTVCS
*	addq.w	#6,a7
	move.w	sr,d4
	move.l	d0,2(a7)
	move.w	d3,(a7)
	DOS	__INTVCS
	btst.l	#$0d,d4
	beq	L000e7e
	moveq.l	#$ff,d0
	bra	L000e84
L000e7e:
	move.l	L000f6a,d0
L000e84:
	addq.w	#6,a7
	movem.l	(a7)+,d3-d4
*	unlk	a6
	rts

L000e8e:
	link	a6,#-2
	move.l	d3,-(a7)
	tst.l	$0008(a6)
	beq	L000ea4
	bsr	L000e50
	tst.l	d0
	beq	L000ea4
	moveq.l	#$00,d3
	bra	L000ea6
L000ea4:
	moveq.l	#$02,d3
L000ea6:
	move.w	#$0002,-(a7)
	pea.l	-$0002(a6)
	move.l	#$00e9e000,-(a7)
	DOS	__MEMCPY
	lea.l	$000a(a7),a7
	tst.l	d0
	bne	L000ec8
	jsr	__fpuinit
	moveq.l	#$01,d1
	or.l	d1,d3
L000ec8:
	move.l	d3,d0
	move.l	-$0006(a6),d3
	unlk	a6
	rts

__iscopro:
	link	a6,#0
	movea.l	#$00000cbc,a1
	IOCS	__B_BPEEK
	moveq.l	#$04,d1
	cmp.l	d1,d0
	bhi	L000f26
	add.l	d0,d0
	move.w	L000ef0(pc,d0.l),d1
	jmp	L000ef0(pc,d1.w)

L000ef0:
	.dc.w	L000efa-L000ef0
	.dc.w	L000f00-L000ef0
	.dc.w	L000f0e-L000ef0
	.dc.w	L000f0e-L000ef0
	.dc.w	L000f0e-L000ef0
L000efa:
	pea.l	1.w
	bra	L000f04
L000f00:
	pea.l	0.w
L000f04:
	bsr	L000e8e
	move.b	d0,__ohavefpu
	bra	L000f2e
L000f0e:
	movea.l	#$00000cbd,a1
	IOCS	__B_BPEEK
	tst.l	d0
	beq	L000f26
	move.b	#$06,__ohavefpu
	bra	L000f2e
L000f26:
	move.b	#$02,__ohavefpu
L000f2e:
	move.b	__ohavefpu,d0
	ext.w	d0
	ext.l	d0
	unlk	a6
	rts

__fpuinit:
	pea.l	0.w
	DOS	__SUPER
	move.w	#$0000,$00e9e006
	addq.w	#4,a7
	tst.l	d0
	ble	L000f56
	move.l	d0,-(a7)
	DOS	__SUPER
	addq.w	#4,a7
L000f56:
	rts

__f_cmpdf2:
	.dc.b	$4e,$56,$ff,$f8,$f2,$2e,$54,$00
	.dc.b	$00,$08,$f2,$2e,$54,$80,$00,$10
	.dc.b	$f2,$00,$04,$28,$f2,$2e,$74,$00
	.dc.b	$ff,$f8,$20,$2e,$ff,$f8,$c0,$bc
	.dc.b	$7f,$ff,$ff,$ff,$66,$0a,$4a,$ae
	.dc.b	$ff,$fc,$66,$04,$70,$00,$60,$14
	.dc.b	$12,$2e,$ff,$f8,$ee,$09,$70,$00
	.dc.b	$10,$01,$4a,$80,$67,$04,$70,$ff
	.dc.b	$60,$02,$70,$01,$4e,$5e,$4e,$75
__fpu_cmpdf2:
	lea.l	$00e9e000,a0
	lea.l	$0010(a0),a1
	lea.l	$000a(a0),a2
	link	a6,#-8
	move.w	#$5400,(a2)
L000cb6:
	cmpi.w	#$8900,(a0)
	beq	L000cb6
	move.l	$0008(a6),(a1)
	move.l	$000c(a6),(a1)
L000cc4:
	tst.w	(a0)
	bmi	L000cc4
	move.w	#$5480,(a2)
L000ccc:
	cmpi.w	#$8900,(a0)
	beq	L000ccc
	move.l	$0010(a6),(a1)
	move.l	$0014(a6),(a1)
L000cda:
	tst.w	(a0)
	bmi	L000cda
	move.w	#$0428,(a2)
L000ce2:
	tst.w	(a0)
	bmi	L000ce2
	move.w	#$7400,(a2)
L000cea:
	cmpi.w	#$8900,(a0)
	beq	L000cea
	move.l	(a1),-$0008(a6)
	move.l	(a1),-$0004(a6)
	move.l	-$0008(a6),d0
	and.l	#$7fffffff,d0
	bne	L000d0e
	tst.l	-$0004(a6)
	bne	L000d0e
	moveq.l	#$00,d0
	bra	L000d22
L000d0e:
	move.b	-$0008(a6),d1
	lsr.b	#7,d1
	moveq.l	#$00,d0
	move.b	d1,d0
	tst.l	d0
	beq	L000d20
	moveq.l	#$ff,d0
	bra	L000d22
L000d20:
	moveq.l	#$01,d0
L000d22:
	unlk	a6
	rts

__fe_cmpdf2:
	link	a6,#-8
	move.l	d3,-(a7)
	move.l	$0010(a6),d2
	move.l	$0014(a6),d3
	move.l	$0008(a6),d0
	move.l	$000c(a6),d1
	FPACK	__DSUB
	move.l	d0,-$0008(a6)
	move.l	d1,-$0004(a6)
	move.l	-$0008(a6),d0
	and.l	#$7fffffff,d0
	bne	L000d5c
	tst.l	-$0004(a6)
	bne	L000d5c
	moveq.l	#$00,d0
	bra	L000d70
L000d5c:
	move.b	-$0008(a6),d1
	lsr.b	#7,d1
	moveq.l	#$00,d0
	move.b	d1,d0
	tst.l	d0
	beq	L000d6e
	moveq.l	#$ff,d0
	bra	L000d70
L000d6e:
	moveq.l	#$01,d0
L000d70:
	move.l	-$000c(a6),d3
	unlk	a6
*	rts

	.data
	.even
__havefpu:
	.dc.b	$02
__ohavefpu:
	.dc.b	$02
	.even
	.bss
	.even
L000f6a:
	.ds.l	1
	.even
	.text
" : : );
#endif
