/* Configuration for GNU C-compiler for Motorola 68000 family.
   Copyright (C) 1987 Free Software Foundation, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


/* #defines that need visibility everywhere.  */
#define FALSE 0
#define TRUE 1

/* This describes the machine the compiler is hosted on.  */
#define HOST_BITS_PER_CHAR      8
#define HOST_BITS_PER_SHORT    16
#define HOST_BITS_PER_INT      32
#define HOST_BITS_PER_LONG     32
#define HOST_BITS_PER_LONGLONG 64

#define HOST_WORDS_BIG_ENDIAN 0

/* target machine dependencies.
   tm.h is a symbolic link to the actual target specific file.   */
#include "tm.h"

#undef MACHINE_STATE_SAVE
#if defined(__mcf5200__)
#define MACHINE_STATE_SAVE(id)		      \
    {					      \
      asm ("sub.l   #28,sp" : );	      \
      asm ("movem.l d0/d1/d2/a0/a1/a2,4(sp)" : ); \
      asm ("move.w  ccr,d0" : );	      \
      asm ("movem.l d0,(sp)" : );	      \
    }
#elif defined(MACHINE_STATE_m68010_up)
#define MACHINE_STATE_SAVE(id)		          \
    {					          \
      asm ("move.w  ccr,-(sp)" : );	          \
      asm ("movem.l d0/d1/d2/a0/a1/a2,-(sp)" : ); \
    }
#else
#define MACHINE_STATE_SAVE(id)		          \
    {					          \
      asm ("move.w  sr,-(sp)" : );	          \
      asm ("movem.l d0/d1/d2/a0/a1/a2,-(sp)" : ); \
    }
#endif

#undef MACHINE_STATE_RESTORE
#if defined(__mcf5200__)
#define MACHINE_STATE_RESTORE(id)	          \
    {					          \
      asm ("movem.l (sp),d0");	                  \
      asm ("move.w d0,ccr");		          \
      asm ("movem.l 4(sp),d0/d1/d2/a0/a1/a2");    \
      asm ("addi.l #28,sp");		          \
    }
#else
#define MACHINE_STATE_RESTORE(id)	          \
    {					          \
      asm ("movem.l (sp)+,d0/d1/d2/a0/a1/a2");    \
      asm ("move.w (sp)+,ccr");		          \
    }
#endif

#undef WORDS_BIG_ENDIAN
#define WORDS_BIG_ENDIAN 0
/* Arguments to use with `exit'.  */
#define SUCCESS_EXIT_CODE 0
#define FATAL_EXIT_CODE 33

/* If compiled with GNU C, use the built-in alloca */
#ifdef __GNUC__
/* Use an arg in this macro because that's what some other
   system does--let's avoid conflict.  */
#define alloca(x) __builtin_alloca(x)
#endif

#undef INCOMING_RETURN_ADDR_RTX
#undef DWARF_FRAME_REGNUM
#undef INCOMEING_FRAME_SP_OFFSET 
#undef DWARF2_UNWIND_INFO

#define _STDDEF_H_
#include <stddef.h>
